Subject: Re: PLUG-discuss Digest, Vol 235, Issue 15

From: Stephen Partington via PLUG-discuss <[email-masked]>
Date: Wed, 22 Jan 2025 10:25:59 -0500

Good luck, and take care.

To subscribe or unsubscribe via the World Wide Web, visit
   https://lists.phxlinux.org/mailman/listinfo/plug-discuss

On Mon, Jan 20, 2025 at 5:39 AM William Hooper via PLUG-discuss <
[email-masked]> wrote:

> unsubscribe please
> retiring
>
>
> from my iPhone 9
>
> On Jan 19, 2025, at 12:39, [email-masked] wrote:
>
> Send PLUG-discuss mailing list submissions to
>    [email-masked]
>
> To subscribe or unsubscribe via the World Wide Web, visit
>    https://lists.phxlinux.org/mailman/listinfo/plug-discuss
> or, via email, send a message with subject or body 'help' to
>    [email-masked]
>
> You can reach the person managing the list at
>    [email-masked]
>
> When replying, please edit your Subject line so it is more specific
> than "Re: Contents of PLUG-discuss digest..."
>
>
> Today's Topics:
>
>   1. Re: WordPress Move to JavaScript (James Dugger)
>
>
> ----------------------------------------------------------------------
>
> Message: 1
> Date: Sat, 18 Jan 2025 02:15:37 -0700
> From: James Dugger <[email-masked]>
> To: Main PLUG discussion list <[email-masked]>
> Subject: Re: WordPress Move to JavaScript
> Message-ID:
>    <[email-masked]>
> Content-Type: text/plain; charset="utf-8"
>
> I know this is old but thought I would add some perspective.  WordPress'
> plugin ecosystem is too big. Its primary audience is what I call site
> builders - individuals with some coding experience mainly in html, and CSS
> and maybe a bit of javascript's jquery library. Although that latter is
> probably pushing it. I went to WordCamp 8 years ago in Phoenix as a GoDaddy
> rep.  Most of the people and even the talks were geared towards non-coding
> professionals.  Most people there wouldn't have been able to explain what
> an object was in any language and couldn't blueprint a class declaration or
> any of its mechanics.
>
> Where do they go - If they don't want to pay for real development they head
> to Squarespace or Weebly or other no-code solutions.
>
> Most of the use cases for WordPress I am familiar with are for small
> businesses.  Most hosting companies have auto site builders that construct
> the website in 30 seconds.  But then people quickly get bogged down in even
> finding, picking, installing and implementing the plugins correctly after
> the initial build. Often they are left with hacked, or bloated sites that
> leave them exposed and filled with malware.  I helped an agency clean up a
> WordPress website for a plastic surgeon where the MySQL database had been
> injected with Russian phishing data.  The site was 5 years old and I found
> over 150k nefarious entries that had to be cleaned up and removed.
>
> Later I worked for a tech firm that consults for large corporate clients
> that use WordPress for limited sites, like a digital magazine for high end
> real estate holdings, almost like a brochure version of Architectural
> Digest. In these cases WP works because we would limit the number of
> plugins and user interaction with the site.  We could have easily built
> these sites without WP and often did, but if they were going to maintain
> the site the contracts would dictate that we had to build it in WP.
>
> I think that the current metrics are around 43% of the web uses WordPress.
> I would estimate that easily 70% of the database and the codebase in WP is
> for managing the application and has little to do with the actual visual
> website that the general public see and interact with - excluding ecommerce
> and subscription-based web apps that need user account transactions.  A
> typical WP site is over 1 million lines of code.
>
> But when the same companies hired us to build enterprise-based solutions
> and wanted a PHP-based web application the choices were usually Drupal for
> sites that needed a CMS and Laravel for sites that didn't. Even if they
> wanted a SPA (single page application) like React, Angular, or Vue, we
> recommended the backend be built in Laravel and not Express (Node).  Drupal
> is based on the Symfony PHP framework and Laravel hooks into it. Symfony is
> by far the most well supported open source PHP solution.  The irony is that
> there are enough good libraries both on the JavaScript and PHP that are
> better written, more secure, and just as easy to implement than going to a
> WP-based approach.  Plus I have to wonder what is going on with Automatic
> and WP Engine and what is the future of WordPress.
>
> For sites that need to be sped up and are limited to remain on older server
> instances.  My advice is to simplify the code base as much as possible.  So
> roll your own framework or use a lightweight MVC framework. Turn on opcode
> (APC) and object caching (Redis) and if you are using Apache as your
> Webserver play with the MaxClient settings to dial in the amount of
> preforking that Apache does.  Setting  the number too high in MySQL will
> cause thrashing when the database constantly has to write data out to the
> disk to clear up memory to add threads.  Or switch to Nginx as the
> webserver.
>
> Package These up in a Docker container or containers (web server, database
> server) running a lightweight Linux instance and you have a portable web
> application that can be installed anywhere and spun up in seconds.
>
> On Fri, Nov 15, 2024 at 12:17?PM Keith Smith via PLUG-discuss <
> [email-masked]> wrote:
>
> > Thank You David,
> >
> > I agree WordPress is bloated and it is one-size-fits-all.  I saw a video
> > recently that WordPress has 40% market share.
> >
> > I am hoping to build my own infrastructure within a year and a half.
> >
> > I think potentially the back end JS issue is my problem.  That is why I
> > mentioned my daily driver is a 10 year old Dell with an i5 and 16G of
> > RAM. It is running an SSD that helps. Seems 32G is the minimum
> > now....Yikes
> >
> > Another issue is Google has removed 12 of my articles because of
> > redirects.  I've looked at it several times and cannot figure it out.  I
> > did not add the redirects.  I wonder if it is WordPress that is doing
> > something.
> >
> > Other than a more powerful CPU and more RAM what is the solution?  Is
> > there a point when people start to exit WordPress, and where do they go?
> >
> >
> >
> >
> > On 2024-11-13 12:47, David Schwartz via PLUG-discuss wrote:
> >> Javascript runs in the browser. Most issues I hear about and encounter
> >> myself end up being browser-related.
> >>
> >> You mentined all of the things that aren?t connected to JS, and did not
> >> mention the one(s) that are. JS is the primary source of problems
> >> today. And hackers that break into the back-end.
> >>
> >> I operate almost exclusively on Macs and my Android phone, and I?ve got
> >> between three and six browsers on each one. None of them work the same
> >> ? which is to say, when I run into a problem on one, I can usually
> >> solve it by switching to another browser. Every week it?s something
> >> different.
> >>
> >> The source of the problem is not worth my time to figure it out, and
> >> it?s really easy to switch to another browser.
> >>
> >> Don?t blame php or the back-end for quirks that are endemic to JS
> >> running in one specific browser. Even updates of the same browser can
> >> behave differently. And the behavior on the same browser can change
> >> from one day to the next, or one hour to the next. Nobody is changing
> >> the back-end that frequently, I can assure you. It?s the libraries the
> >> pages are loading up, or the code the site?s developers changed last
> >> night.
> >>
> >> I?ve been writing code in Delphi using TMS WEB Core, which is available
> >> both as a Delphi addon and a standalone package that runs in Visual
> >> Studio Code. It takes Delphi code (Object Pascal) and translates it
> >> into JS and packages it up so it runs in the browser. NONE of it is
> >> running in the back-end! It?s 100% browser based. And 100% of the weird
> >> issues I have are all browser related. Sure, there are bugs in the
> >> platform, but they are typically reproduced the same in every browser.
> >> Browser issues show up differently in one browser, maybe two, but not
> >> in all of them.
> >>
> >> A lot of browsers are using the Chromium engine, so quirks in it can be
> >> reflected elsewhere, but they usually need to be running the same
> >> version of the engine for them to show up.
> >>
> >> It used to be that you had to test software on different machines from
> >> different vendors, different versions of Windows or MacOS, and it cost
> >> you a lot of money to have all of those combinations of software and
> >> hardware available for testing.
> >>
> >> Today you just need to test on one hardware platform with variations of
> >> browsers loaded on it, probably running in separate VMs or docker
> >> images to ensure you test with different versions of Chromium and
> >> whatnot.
> >>
> >> Same old sh*t, different approach.
> >>
> >> As far as WP goes, I think it?s internal architecture has become
> >> obsolete. Layers and layers of crap have been added to convert
> >> asynchronous events into something that serializes them, and the people
> >> writing plugins and themes are mostly inexperienced coders who don?t
> >> have a clue what?s what. Meanwhile there are people who have nothing
> >> else to do with their life but find ways to sneak into cracks and
> >> crevices in the back-end, and sometimes wide-open doors, left by said
> >> inexperienced coders who didn?t do a good job testing their code. ?It
> >> works! Ship it!?
> >>
> >> The UX/UI logic is all being pushed out to the browser, and the
> >> business logic is being hidden behind REST APIs. I can build something
> >> in TMS WEB Core way faster than it takes to build in WP ? it runs
> >> faster, is more solid, and is far easier to maintain. That can probably
> >> be said of most JS-based UX/UI dev tools today.
> >>
> >> The problem with Wordpress is ? it?s Wordpress. The UX/UI is tightly
> >> coupled to the back-end because all of the user?s state is managed in
> >> the back-end. And it?s not an API, but just a huge mess of functions
> >> that are designed to be hijacked by programmers to get it to do pretty
> >> much anything out of the ordinary ? if you can?t get it to support
> >> something in the UI, you need to build a plugin or theme to add it. And
> >> that code lives on the BACK-END and is susceptible to all of the myriad
> >> ways there are for hackers to throw sand in the gears. The whole damn
> >> platform is open to anybody who wants to poke and prod it?s guts! They
> >> even added an API but nobody uses it.
> >>
> >> If I need something to work a certain way using WEB Core, I can easily
> >> program it. I hide necessary business logic behind an authenticated
> >> REST API and the JS in the browser manages it all. The events are all
> >> asynchronous and I don?t have to worry about someone hacking into the
> >> back-end code and hijacking everything. I can build the services in any
> >> language and host it on any platform I want.
> >>
> >> In WP, you have to build a plugin and plan to maintain it as further WP
> >> updates will very likely break it in some unexpected way. Or if not the
> >> WP code than maybe one of the UI libs you?re working with change and
> >> someone updated a theme that loads a different version and screws up
> >> your code.
> >>
> >> IMHO, WP is just a big fat ugly mess that only gets worse over time.
> >>
> >> Just switch to a no-code / low-code solution that lets you custom-build
> >> what you need, and that isn?t dependent on dozens of things that can
> >> change from week to week and month to month as the underlying platform
> >> is patched to fix newly-discovered exploits and the UI libs get updated
> >> by updates in the plugins and themes.
> >>
> >> -David Schwartz
> >>
> >>
> >>
> >>
> >>> On Nov 13, 2024, at 9:12 AM, Keith Smith via PLUG-discuss
> >>> <[email-masked]> wrote:
> >>>
> >>> Hi,
> >>>
> >>> This is kind of off topic, however WordPress is Open Source and I
> >>> would expect that the vast majority of WordPress is run on LAMP
> >>> servers.
> >>>
> >>> My daily driver is a 10 year old Dell that has an i5 with 16G of RAM
> >>> that runs Kubuntu 24.04lts.
> >>>
> >>> I am running a blog using WordPress that is hosted on an Ubuntu
> >>> server.
> >>>
> >>> I am having issues with the WordPress Gutenberg back end.  I cannot
> >>> get it to do the things I want to do like bold text. At times is is
> >>> sluggish.  I've read that WordPress has a 10 year plan to move to
> >>> JavaScript.  There is not a lot of info available so it is unclear if
> >>> the PHP code will be replaced as well.  If WordPress replaces the PHP
> >>> back end I will leave WordPress.  As it is WordPress is hanging by a
> >>> thread.
> >>>
> >>> These problems are new. I am also having formatting issues which might
> >>> be due to my theme.
> >>>
> >>> Is anyone having these issues or maybe other issues with WordPress?
> >>>
> >>> Ultimately I may create my own infrastructure or start building my own
> >>> theme.
> >>>
> >>> Any feedback is very welcome.
> >>>
> >>> Keith
> >>> ---------------------------------------------------
> >>> PLUG-discuss mailing list: [email-masked]
> >>> To subscribe, unsubscribe, or to change your mail settings:
> >>> https://lists.phxlinux.org/mailman/listinfo/plug-discuss
> >>
> >> ---------------------------------------------------
> >> PLUG-discuss mailing list: [email-masked]
> >> To subscribe, unsubscribe, or to change your mail settings:
> >> https://lists.phxlinux.org/mailman/listinfo/plug-discuss
> > ---------------------------------------------------
> > PLUG-discuss mailing list: [email-masked]
> > To subscribe, unsubscribe, or to change your mail settings:
> > https://lists.phxlinux.org/mailman/listinfo/plug-discuss
> >
>
>
> --
> James
>
> *Linkedin <http://www.linkedin.com/pub/james-h-dugger/15/64b/74a/>*
> -------------- next part --------------
> An HTML attachment was scrubbed...
> URL: <
> http://lists.phxlinux.org/pipermail/plug-discuss/attachments/20250118/01809e07/attachment-0001.htm
> >
>
> ------------------------------
>
> Subject: Digest Footer
>
> _______________________________________________
> PLUG-discuss mailing list  -  [email-masked]
> To subscribe, unsubscribe, or to change your mail settings:
> https://lists.phxlinux.org/mailman/listinfo/plug-discuss
>
>
> ------------------------------
>
> End of PLUG-discuss Digest, Vol 235, Issue 15
> *********************************************
> ---------------------------------------------------
> PLUG-discuss mailing list: [email-masked]
> To subscribe, unsubscribe, or to change your mail settings:
> https://lists.phxlinux.org/mailman/listinfo/plug-discuss
>

-- 
A mouse trap, placed on top of your alarm clock, will prevent you from
rolling over and going back to sleep after you hit the snooze button.

Stephen
---------------------------------------------------
PLUG-discuss mailing list: [email-masked]
To subscribe, unsubscribe, or to change your mail settings:
https://lists.phxlinux.org/mailman/listinfo/plug-discuss